package core;

import java.text.ParseException;
import java.io.*;
import java.util.Stack;

class Sequente{
  No info;
  Sequente proximo=null;
  boolean consequencia;

  void insere(No x, boolean conseq)
  { //a ordem aqui não importa mesmo...
    //esse metodo so sera executado pela cabeça de lista
      if (x==null)
	  return;
      Sequente novo=new Sequente();
      novo.info=x;
      novo.consequencia=conseq;
      novo.proximo=this.proximo;
      this.proximo=novo;
  }
}

class No{
  String info;
  No filho1=null;
  No filho2=null;
  No (char i)
  {
    info=""+i;
  }
  No (int i)
  {
    info=""+i;
  }
}
class Parser {
  int atomos=0;
  
  Sequente parseTudo(String arq) throws ParseException, IOException, FileNotFoundException
  {
    FileReader file=new FileReader(arq);
    int c;
    String linha="";
    boolean consequencia=false;
    Sequente saida=new Sequente();
    saida.info=new No(-1);
    //le o arquivo todo...
    while ((c=file.read())!=-1)
    {
      if (c!='\n' && c!='\r')
        linha+=(char)c;
      else  //fim da linha
        if (linha.equals("|="))
	{
	    consequencia=true;
	    linha="";
	}else if (linha.length()>0)
	{
	    saida.insere(parse(linha),consequencia);
	    linha="";
	}
    }
    if (linha.length()>0)
    {
      saida.insere(parse(linha),consequencia);
      linha="";
    }
    if (!consequencia)
      throw new ParseException("Não houveram consequencias (Sem sinal \"|=\")" , 0);
    return saida.proximo; //Nao retornamos a cabeca por questoes de compatibilidade...
  }
  private int precedencia(No operador)
  {
    if (operador.info.equals("~"))
      return 3;
    else if (operador.info.equals("&"))
      return 2;
    else if (operador.info.equals("|"))
      return 1;
    else if (operador.info.equals(">"))
      return 0;
    else //Alguma outra coisa
      return -1;
  }
  private int precedencia(char operador)
  {
    if (operador=='~')
      return 3;
    else if (operador=='&')
      return 2;
    else if (operador=='|')
      return 1;
    else if (operador=='>')
      return 0;
    else //Alguma outra coisa
      return -1;
  }
  No parse(String formula) throws ParseException
  {
    int i;
    No saida=null;
    Stack<No> operandos=new Stack<No>();
    Stack<No> operadores=new Stack<No>();
    for(int[] pos={0};pos[0]<formula.length();pos[0]++) //Declaramos pos como array para poder passar por referencia...
    {
      i=leNum(formula,pos);
      if(i>0) //operando
      {
	  operandos.push(new No(i));
	  if (i>atomos)
	      atomos=i;
      }      
      else //operador
	  if (operadores.empty() || formula.charAt(pos[0])=='(')
	    operadores.push(new No(formula.charAt(pos[0])));
	  else if(formula.charAt(pos[0])==')')
	  {
	      while(!((No)operadores.peek()).info.equals("("))
		  montaNo(operandos,operadores);
	      operadores.pop();
	  }
	  else
	  {
	      while(precedencia(formula.charAt(pos[0])) <= precedencia((No)operadores.peek()))
	      {
		  montaNo(operandos,operadores);
		  if(operadores.empty())
		      break;
	      }
	      operadores.push(new No(formula.charAt(pos[0])));
	  }
    }
    while(!operadores.empty())
      montaNo(operandos,operadores);
    try
    {
      saida=(No)operandos.pop();
    }
    catch (java.util.EmptyStackException e)
    {
      return null;
    }
    if (!operandos.empty())
      throw new ParseException("Erro ao interpretar a fórmula",0);
    return saida;
  }
  void montaNo(Stack<No> operandos, Stack<No> operadores)
  {
    No resul=(No)operadores.pop();
    if (resul.info.equals("~"))
      resul.filho1=(No)operandos.pop();
    else
    {
      resul.filho2=(No)operandos.pop();
      resul.filho1=(No)operandos.pop();
    }
    operandos.push(resul);
  }
  private int leNum(String formula,int[] posicao)
  {
    //esse pokemon pega numeros com mais de um digito...
    int num=0;
    int pos=posicao[0];
    while(formula.charAt(pos)=='0'||formula.charAt(pos)=='1'||formula.charAt(pos)=='2'||formula.charAt(pos)=='3'||
          formula.charAt(pos)=='4'||formula.charAt(pos)=='5'||formula.charAt(pos)=='6'||formula.charAt(pos)=='7'||
           formula.charAt(pos)=='8'||formula.charAt(pos)=='9')
    {
      num*=10;
      num+= formula.charAt(pos)-'0';
      pos++;
      if (pos==formula.length())
        break;
    }
    if (num>0)
      pos--; //Para que o proximo caracter seja pego corretamente
    posicao[0]=pos;
    return num;
  }
}
