package plugins;

import java.math.BigInteger;
import java.util.ArrayList;

import core.Monomio;

public class NovoMetodo implements Plugin {

	public static final String info="Implementa o novo método desenvolvido pelo autor. Um pouco parecido com o método" +
			"de Dubois. Essa primeira versão só resolve problemas 3-TAUT (com EXATAMENTE 3 literais por conjunção)"; 
	public static final String nome="Método pensado pelo autor (Eduardo Menezes de Morais)";
	public long iteracoes=0;
	public long getIteracoes() {
		return iteracoes;
	}
	public static final BigInteger BigIntegerSeven=new BigInteger("7");
	public static final BigInteger BigIntegerEight=new BigInteger("8");
	public static final BigInteger BigIntegerTwo=new BigInteger("2");
	
	public BigInteger contaInterp(int vars, ArrayList<Monomio> formula) {
		//debug(formula);
		//debug("\n\n");
		if (vars==0) return BigInteger.ZERO;
		int nvars_falso;
		final int tamanho_formula=formula.size();
		ArrayList<Monomio[]> conflitos=new ArrayList<Monomio[]>(2*tamanho_formula);
		BigInteger result, result_provisorio;
		try {
			result=BigInteger.ONE.shiftLeft(vars-formula.get(0).qtdeLiterais());
		} catch (java.lang.IndexOutOfBoundsException e) {
			return BigInteger.ZERO;
		}
		//debug(formula.get(0));
		//debug(" = "+result+"\n");
		for (int i=1; i<tamanho_formula; i++){
			//debug(formula.get(i));
			//debug(":\n");
			nvars_falso=Math.max(3*(i+1), vars);
			//debug("nvars_falso="+nvars_falso+"\n");
			conflitos=gera_conflitos(formula, i);
			result_provisorio=(BigInteger.ONE.shiftLeft(nvars_falso).multiply(BigIntegerSeven.pow(i))).divide(BigIntegerEight.pow(i+1));
			//subresult=new BigInteger(result_provisorio.toByteArray()); //subresult=result_provisorio
			//debug("result_provisorio="+result_provisorio+"\n");
			for (int j=0; j<conflitos.size(); j++) {
				result_provisorio=result_provisorio.add(resolveConflito(formula, i, conflitos, j, result_provisorio));
			}
			//debug("Total="+result_provisorio+"\n");
			result=result.add(result_provisorio.divide(BigInteger.ONE.shiftLeft(nvars_falso-vars)));
			//debug("Grantotal="+result+"\n\n");
			
		}
		return result;
	}

	private BigInteger resolveConflito(ArrayList<Monomio> formula, int indiceAtual, 
			ArrayList<Monomio[]> conflitos, int conflitoAtual, BigInteger result_provisorio) {
		// TODO Aqui é a coisa fudida...
		byte[][] conj1, conj2;
		final int num_vars=conflitos.get(0)[0].getTamanho();
		byte sinal=0;
		BigInteger result=BigInteger.ZERO;
		BigInteger result_aux, fracoes_aux;
		ArrayList<BigInteger> fracoes = new ArrayList<BigInteger>();
		int aux=0;
		conj1=new byte[3][];
		conj1[0]=new byte[1]; conj1[1]=new byte[2]; conj1[2]=new byte[3];
		// Primeiro vamos "expandir" esse conflito: ver onde está o problema
		for (int i=0; i<num_vars; i++)
			if (conflitos.get(conflitoAtual)[0].valor[i]!=0){
				for(int j=2;j>=aux; j--)
					if (j==aux) conj1[j][aux]=(byte)(-(i+1) * conflitos.get(conflitoAtual)[0].valor[i]); else conj1[j][aux]=(byte) ((i+1) * conflitos.get(conflitoAtual)[0].valor[i]); 
				aux++;
			}
		if (conflitos.get(conflitoAtual).length==1)
		{
			conj2=new byte[1][3];
			aux=0;
			for (int i=0; i<num_vars; i++)
				if(formula.get(indiceAtual).valor[i]!=0) conj2[0][aux++]=(byte) ((i+1) * formula.get(indiceAtual).valor[i]);
			//Tudo pronto, agora é só tratar.
			for(int i=0; i<conj1.length; i++) {
				aux=1;
				//Vemos "qual o problema"
				sinal=0;
				problema:
				for(int j=0; j<conj1[i].length; j++) 
					for(int k=0; k<conj2[0].length; k++)
						if(conj1[i][j]==conj2[0][k]){
							sinal+=aux; aux<<=1; 
						}
						else if(conj1[i][j]==-conj2[0][k])
						{
							sinal=-1;
							break problema;
						}
						
				if(sinal!=0) {
					/*debug("Conflito: ");
					debug(conj1[i]);
					debug(" com ");
					debug(conj2[0]);
					debug(": ");*/
					result_aux=result_provisorio.multiply(BigIntegerEight).divide(BigIntegerSeven).divide(BigInteger.ONE.shiftLeft(conj1[i].length)).multiply(new BigInteger(""+sinal));
					//TODO "Desviar" ou duplicar as sub-arvóres de outros conflitos envolvidos na raiz   
					//debug(sinal+" * "+result_provisorio+" * (8/7) ÷ "+BigInteger.ONE.shiftLeft(conj1[i].length)+" = "+ result_aux.toString()+"\n");
					result=result.add(result_aux);
				}
			}
		} else {
			//Não tá achando "onde é o problema"!
			conj2=new byte[3][]; conj2[0]=new byte[1]; conj2[1]=new byte[2]; conj2[2]=new byte[3];
			aux=0;
			for (int i=0; i<num_vars; i++)
				if (conflitos.get(conflitoAtual)[1].valor[i]!=0){
					for(int j=2;j>=aux; j--)
						if (j==aux) conj2[j][aux]=(byte)(-(i+1) * conflitos.get(conflitoAtual)[1].valor[i]); else conj2[j][aux]=(byte) ((i+1) * conflitos.get(conflitoAtual)[1].valor[i]); 
					aux++;
				}
			//Tudo pronto, agora é só tratar.
			for(int l=0; l<conj2.length; l++) {
				for(int i=0; i<conj1.length; i++) {
					aux=1;
					//Vemos "qual o problema"
					sinal=0;
					problema:
					for(int j=0; j<conj1[i].length; j++) 
						for(int k=0; k<conj2[l].length; k++)
							if(conj1[i][j]==conj2[l][k]){
								sinal+=aux; aux<<=1;
							}else if(conj1[i][j]==-conj2[l][k])
							{
								sinal=-1;
								break problema;
							}
							
					if(sinal!=0) {
						/*debug("Conflito: ");
						debug(conj1[i]);
						debug(" com ");
						debug(conj2[l]);
						debug(": ");*/
						result_aux=result_provisorio.multiply(BigIntegerEight).multiply(BigIntegerEight).
							divide(BigIntegerSeven).divide(BigIntegerSeven).divide(BigInteger.ONE.shiftLeft(conj1[i].length)).
							divide(BigInteger.ONE.shiftLeft(conj2[l].length)).multiply(new BigInteger(""+sinal));
						/*debug(sinal+" * "+result_provisorio+" * (8/7)² ÷ "+BigInteger.ONE.shiftLeft(conj1[i].length)+" ÷ "+
								BigInteger.ONE.shiftLeft(conj2[l].length)+" = "+ result_aux.toString()+"\n");*/
						fracoes.clear();
						try {
							arrumaConflitos(formula, indiceAtual,conflitos, conflitoAtual, fracoes);
							for(java.util.Iterator<BigInteger> ind = fracoes.iterator(); ind.hasNext();)
							{
								fracoes_aux=ind.next();
								result_aux=result_aux.add(result_aux.multiply(BigIntegerEight).divide(BigIntegerSeven).divide(fracoes_aux));
								//debug("(* (8/7) ÷ "+fracoes_aux+")");
							}
							result=result.add(result_aux);
							//debug(" ("+result.toString()+")\n");
						} catch(ConflitoEliminadoException e){
							//debug("(Conflito eliminado devido a conflito anterior)\n");
							continue; //Zerado. Pula para o próximo
						} catch(ConflitoDuplicadoException e){
							//debug("(Conflito duplicado devido a conflito anterior)\n");
							result=result.add(result_aux.multiply(BigIntegerTwo)); //Esse não tinha que ser exception. Pode ter mais coisa!
						}
					}
				}
			}
		}
		return result;
	}

	void arrumaConflitos(ArrayList<Monomio> formula, int indiceAtual,
			ArrayList<Monomio[]> conflitos, int conflitoAtual,
			ArrayList<BigInteger> fracoes) throws ConflitoEliminadoException, ConflitoDuplicadoException {
		// TODO Arrumar.
		Monomio[] conflito1, conflito2=conflitos.get(conflitoAtual);
		boolean achou=false;
		if (conflito2.length==1) return; //Como os conflitos com a raiz são os primeiros, não tem problema
		for(int i=0; i<conflitoAtual; i++){
			conflito1=conflitos.get(i);
			int j;
			achou=false;
			for(j=0; j<conflito1.length; j++) {
				if (conflito1[j]==conflito2[0] || conflito1[j]==conflito2[1]) {
					achou=true;
					break;
				}
			}
			if(!achou) continue;
			if (conflito1.length==2) {
				//TODO Calcular sinal
				fracoes.add(BigInteger.ONE.shiftLeft(conflito1[1-j].qtdeLiterais()));
			} else {
				//Já tem um conflito com a raiz. Se for eliminação, tudo vira zero. Caso contrário, tudo duplica
				//Por enquanto vamos usar excessão. Talvez tenha um jeito mais elegante.
				final int num_vars=conflitos.get(0)[0].getTamanho();
				for (int var=0; var<num_vars; var++)
					if (formula.get(indiceAtual).valor[var]==-conflito1[0].valor[var])
						throw new ConflitoEliminadoException();
				throw new ConflitoDuplicadoException(); //Esse não tinha que ser exception. Pode ter mais coisa!
			}
		}
		
	}

	private ArrayList<Monomio[]> gera_conflitos(ArrayList<Monomio> formula, int i) {
		ArrayList<Monomio[]> result=new ArrayList<Monomio[]>();
		Monomio[] novoConflito;
		/* Primeiro vamos verificar conflitos com a raiz (formula[i]). 
		 * Os conflitos com a raiz devem ser tratados primeiro
		 */
		for (int j=0; j<i; j++)
		{
			if(formula.get(j).varComum(formula.get(i))) {
				novoConflito=new Monomio[1];
				novoConflito[0]=formula.get(j);
				/*debug("Conflito: ");
				debug(novoConflito[0]);
				debug(" com raiz\n");*/
				result.add(novoConflito);
			}
		}
		
		for (int j=0; j<i; j++)
		{
			for (int k=j; k<i; k++)
			{
				if(j==k) continue;
				if(formula.get(j).varComum(formula.get(k))) {
					novoConflito=new Monomio[2];
					novoConflito[0]=formula.get(j);
					novoConflito[1]=formula.get(k);
					/*debug("Conflito: ");
					debug(novoConflito[0]);
					debug(" com ");
					debug(novoConflito[1]);
					debug("\n");*/
					result.add(novoConflito);
				}
			}
		}
		return result;
	}
	
	private void debug(String msg) {
//		System.out.print(msg);
	}
	private void debug(Monomio msg) {
		/*System.out.print("[ ");
		for (int i=0; i<msg.getTamanho(); i++)
			if (msg.valor[i]!=0){
					System.out.print(((i+1) * msg.valor[i])+" "); 
			}
		System.out.print(']');*/
	}
	
	private void debug(ArrayList<Monomio> msg) {
		/*System.out.print("{ ");
		for(java.util.Iterator<Monomio> it=msg.iterator(); it.hasNext();)
			debug(it.next());
		System.out.print("}");*/
	}
	
	private void debug(byte[] msg) {
		/*System.out.print("( ");
		for(int i=0; i<msg.length; i++)
			System.out.print(msg[i]+" ");
		System.out.print(")");*/
	}

	public Monomio pegaInterp(int vars, ArrayList<Monomio> formula) {
		return null;
	}

}
