package ui;
//Podia ser multithread...

import java.io.PrintStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Iterator;

import core.Monomio;
import plugins.*;

public final class GeradorAleatorio {
	//Alguns problemas para se ter uma idéia se a implementação de um método está correta

	private static final BigDecimal Cem= new BigDecimal("100");
	public static void main(String[] args) throws Exception {
		int vars, monomios;
		BigInteger result = null;
		BigDecimal porcentagem;
		if (args.length<5) throw new Exception("Uso: GeradorAleatorio <vars> <qtde> <método> <min> <max>");
		vars=Integer.valueOf(args[0]);
		if (vars<1) {
			System.err.println("É necessário especificar um número de variáveis maior que 0!");
			System.exit(1);
		}
		Plugin resolvedor=(Plugin) Class.forName("plugins."+args[2]).newInstance();
		PrintStream output = new PrintStream("formulas.tex");
		output.println("\\documentclass[12pt]{article}");
		output.println("\\usepackage[brazil]{babel}");
		output.println("\\usepackage[latin1]{inputenc}");		
		output.println("\\usepackage{amsmath}");
		output.println("\\begin{document}");
		ArrayList<Monomio> teste=new ArrayList<Monomio>();
		Monomio temp=new Monomio(new byte[vars]);
		int w=0;
		while(w<Integer.valueOf(args[1])){
			monomios=(int)Math.round((Math.random()*2)*vars); //Pega um número aleatório de monomios para a fórmula
			for(int i=0; i<monomios; i++) {
				for (int j=0; j<vars; j++) temp.valor[j]=0;
				while (temp.qtdeLiterais()<3)
					temp.valor[(int) Math.round(Math.random()*(vars-1))]=(Math.random()>=0.5 ? (byte)1 : (byte)-1);
				teste.add(new Monomio(temp.valor));
			}
			try {
				result=resolvedor.contaInterp(vars, teste);
			} catch (Exception e) {
				e.printStackTrace();
				continue;
			}
			porcentagem=new BigDecimal(result).multiply(Cem).divide(new BigDecimal(BigInteger.ONE.shiftLeft(vars)));
			if(porcentagem.intValue() < Integer.parseInt(args[3]) || porcentagem.intValue() > Integer.parseInt(args[4]))
			{
				teste.clear();
				continue;
			}
			
			output.println("\\section{F\\'{o}rmula "+(w+1)+"}");
			output.print(formulaCNFLatex(teste));
			output.println("N\\'{u}mero de interpreta\\c{c}\\~{o}es que satisfazem: "+BigInteger.ONE.shiftLeft(vars).subtract(result)+
					" de um total de "+ BigInteger.ONE.shiftLeft(vars) +" $("+Cem.subtract(porcentagem)+"\\%)$\\\\~\\\\");
			
			output.flush();
			teste.clear();
			System.out.println("Completados "+(w+1)+" de "+args[1]);
			w++;
		}
		output.println("\\end{document}");
	}
	
	private static String formulaCNFLatex(ArrayList<Monomio> teste) {
		String result="$";
		int aux;
		Monomio tmp;
		for(Iterator<Monomio> i=teste.iterator(); i.hasNext();) {
			result+="(";
			tmp=i.next();
			aux=0;
			for(int j=0; j<tmp.getTamanho(); j++) {
				if(tmp.valor[j]>0)  result+="\\lnot ";
				if(tmp.valor[j]!=0) {
					result+="x_{"+j+"}";
					if(aux<2) result+="\\lor ";
					aux++;
				}
			}
			result+=")";
			if (i.hasNext()) result+="\\land ";
		}
		result+="$\\\\";
		return result;
	}

}
